gr = (1+sqrt(5))/2; // golden ratio

module icosohedron(r,br) {
// edge length 2, origin centered vertices at (0,+-1,+-gr),(+-1,+-gr,0), (+-gr,0,+-1)
nf=18;
a1 = [  0  ,  -r ,-gr*r];
a2 = [  0  ,   r ,-gr*r];
b1 = [-r*gr,   0 ,  -r ];
b2 = [ r*gr,   0 ,  -r ];
c1 = [  r  ,-r*gr,   0 ];
c2 = [  r  , r*gr,   0 ];
c3 = [ -r  ,-r*gr,   0 ];
c4 = [ -r  , r*gr,   0 ];
d1 = [-r*gr,   0 ,   r ];
d2 = [ r*gr,   0 ,   r ];
e1 = [  0  ,  -r , gr*r];
e2 = [  0  ,   r , gr*r];

union() {
   hull() { translate(a1) sphere(br,$fn=nf); translate(a2) sphere(br,$fn=nf); }
   hull() { translate(a1) sphere(br,$fn=nf); translate(b1) sphere(br,$fn=nf); }
   hull() { translate(a1) sphere(br,$fn=nf); translate(b2) sphere(br,$fn=nf); }
   hull() { translate(a1) sphere(br,$fn=nf); translate(c1) sphere(br,$fn=nf); }
   hull() { translate(a1) sphere(br,$fn=nf); translate(c3) sphere(br,$fn=nf); }
   hull() { translate(a2) sphere(br,$fn=nf); translate(c2) sphere(br,$fn=nf); }
   hull() { translate(a2) sphere(br,$fn=nf); translate(c4) sphere(br,$fn=nf); }
   hull() { translate(a2) sphere(br,$fn=nf); translate(b1) sphere(br,$fn=nf); }
   hull() { translate(a2) sphere(br,$fn=nf); translate(b2) sphere(br,$fn=nf); }
   hull() { translate(b1) sphere(br,$fn=nf); translate(c3) sphere(br,$fn=nf); }
   hull() { translate(b1) sphere(br,$fn=nf); translate(c4) sphere(br,$fn=nf); }
   hull() { translate(b2) sphere(br,$fn=nf); translate(c1) sphere(br,$fn=nf); }
   hull() { translate(b2) sphere(br,$fn=nf); translate(c2) sphere(br,$fn=nf); }
   hull() { translate(b2) sphere(br,$fn=nf); translate(d2) sphere(br,$fn=nf); }
   hull() { translate(b1) sphere(br,$fn=nf); translate(d1) sphere(br,$fn=nf); }
   hull() { translate(c1) sphere(br,$fn=nf); translate(c3) sphere(br,$fn=nf); }
   hull() { translate(c2) sphere(br,$fn=nf); translate(c4) sphere(br,$fn=nf); }
   hull() { translate(c1) sphere(br,$fn=nf); translate(d2) sphere(br,$fn=nf); }
   hull() { translate(c2) sphere(br,$fn=nf); translate(d2) sphere(br,$fn=nf); }
   hull() { translate(c3) sphere(br,$fn=nf); translate(d1) sphere(br,$fn=nf); }
   hull() { translate(c4) sphere(br,$fn=nf); translate(d1) sphere(br,$fn=nf); }
   hull() { translate(c1) sphere(br,$fn=nf); translate(e1) sphere(br,$fn=nf); }
   hull() { translate(c3) sphere(br,$fn=nf); translate(e1) sphere(br,$fn=nf); }
   hull() { translate(c2) sphere(br,$fn=nf); translate(e2) sphere(br,$fn=nf); }
   hull() { translate(c4) sphere(br,$fn=nf); translate(e2) sphere(br,$fn=nf); }
   hull() { translate(d1) sphere(br,$fn=nf); translate(e1) sphere(br,$fn=nf); }
   hull() { translate(d1) sphere(br,$fn=nf); translate(e2) sphere(br,$fn=nf); }
   hull() { translate(d2) sphere(br,$fn=nf); translate(e1) sphere(br,$fn=nf); }
   hull() { translate(d2) sphere(br,$fn=nf); translate(e2) sphere(br,$fn=nf); }
   hull() { translate(e1) sphere(br,$fn=nf); translate(e2) sphere(br,$fn=nf); }
}}

dd=60;

union(){
translate([0,0,16.34]) { rotate([0,20.91,0])
icosohedron(9.5,2);
difference() { sphere(r=12.3,$fn=48);
               sphere(r=10.3,$fn=12);
    rotate(45,[cos(  90+dd),sin(  90+dd),0]) cylinder(h=25,r=1,$fn=6,center=true);
    rotate(45,[cos( -30+dd),sin( -30+dd),0]) cylinder(h=25,r=1,$fn=6,center=true);
    rotate(45,[cos(-150+dd),sin(-150+dd),0]) cylinder(h=25,r=1,$fn=6,center=true);

    rotate(60+20.91,[cos(-150),sin(-150),0]) cylinder(h=25,r=1,$fn=6,center=true);
    rotate(60+20.91,[cos( -30),sin( -30),0]) cylinder(h=25,r=1,$fn=6,center=true);
    rotate(60+20.91,[cos(  90),sin(  90),0]) cylinder(h=25,r=1,$fn=6,center=true);
}}

cylinder(h=5,r=.6,$fn=6);
for (a=[60,180,300]) {
   translate([10*cos(a),10*sin(a),0]) cylinder(h=10,r=.6,$fn=6); }
}
//%translate([-20,-20,-1]) cube([40,40,1]);
